from vcRslProcessHandler import *
from vcBehaviour import *
import vcMatrix, vcVector, math
import re
app = getApplication()
comp = getComponent()

#-----
class RE(object):
  #---
  #Capsulates RE constants
  #---
  ANY = r'.+'
  SPC = r'\s'
  SPCQ = r'\s*'
  EOL = r'\n'
  INT = r'\s*-?\d+'
  NUM = r'\s*-?\d+\.?\d*[eE]?-?\d*'
  NAME = r'\w+'
  FLAGS = re.I|re.S
#---
def OnStatementAdd(stat):
  for prop in stat.Properties:
    if prop.Name in ['Name', 'Base', 'Tool', 'Process', 'icon']:
      prop.IsVisible = False
#---
def OnStatementGetDescription(stat):
  exp = stat.Expression
  return 'WAIT ' + exp
#-----
def OnStatementExecute(executor, stat):
  exp = stat.Expression
  cycle = stat.PollCycle
  
  prop = comp.getProperty('TestExpression')
  if not prop:
    prop = comp.createProperty(VC_EXPRESSION, 'TestExpression')
  
  replace_these = {}
  replace_these['ON'] = '1'
  replace_these['OFF'] = '0'
  replace_these['<>'] = '!='
  replace_these['NOT'] = '!'
  replace_these['OR'] = '|'
  replace_these['AND'] = '&'
  
  #Format expression for VC style
  exp2 = exp
  for key, value in replace_these.iteritems():
    exp2 = exp2.replace(key, value)
  
  while True:
    #Replace signal expressions
    
    #DO[x]
    re_exp = '(OUT|DO)\[(%s?)\]' % (RE.ANY)
    exp3 = exp2
    exp4 = ''
    match = re.search(re_exp, exp3, RE.FLAGS)
    while match:
      exp4 += exp3[0:match.start()]
      exp3 = exp3[match.end():]
      #
      index = -1
      try:
        index = int(match.group(2))
      except:
        #Try DO[i] where i is property
        try:
          index = int(comp.getProperty(match.group(2)).Value)
        except:
          print 'Parse error in WaitStatement.'
          return
      if index < 0 or index >= executor.DigitalOutputSignals.PortCount:
        print 'DO index error in WaitStatement.'
        return
      value = executor.DigitalOutputSignals.input(index)
      if value:
        exp4 += '1'
      else:
        exp4 += '0'
      #
      match = re.search(re_exp, exp3, RE.FLAGS)
    exp4 += exp3
    
    #DI[x]
    re_exp = '(IN|DI)\[(%s?)\]' % (RE.ANY)
    exp3 = exp4
    exp4 = ''
    match = re.search(re_exp, exp3, RE.FLAGS)
    while match:
      exp4 += exp3[0:match.start()]
      exp3 = exp3[match.end():]
      #
      index = -1
      try:
        index = int(match.group(2))
      except:
        #Try DO[i] where i is property
        try:
          index = int(comp.getProperty(match.group(2)).Value)
        except:
          print 'Parse error in WaitStatement.'
          return
      if index < 0 or index >= executor.DigitalInputSignals.PortCount:
        print 'DI index error in WaitStatement.'
        return
      value = executor.DigitalInputSignals.input(index)
      if value:
        exp4 += '1'
      else:
        exp4 += '0'
      #
      match = re.search(re_exp, exp3, RE.FLAGS)
    exp4 += exp3
    parsed_exp = exp4
    
    #Test expression
    prop.Value = parsed_exp
    if prop.CalculatedValue:
      #Wait condition is true, break
      break
    
    delay(cycle)
#-----