from vcCommand import *
import vcMatrix, os.path
app = getApplication()


def OnStart():

  comp, executor, controller = None, None, None
  if app.TeachContext and app.TeachContext.ActiveRobot:
    comp = app.TeachContext.ActiveRobot
    controllers = comp.findBehavioursByType(VC_ROBOTCONTROLLER)
    executors = comp.findBehavioursByType(VC_ROBOTEXECUTOR)
    if controllers:
      controller = controllers[0]
    if executors:
      executor = executors[0]
  if comp == None or executor == None or controller == None:
    print 'Please select a robot.'
    return ''
  
  #Handler
  script_content = handler()
  process_handler = comp.findBehaviour('WaitHandler')
  if process_handler:
    if process_handler.Script != script_content:
      process_handler.Process = 'Wait'
      process_handler.Script = script_content
      print 'Updated "WaitHandler" behavior.'
  else:
    process_handler = comp.createBehaviour('rPythonProcessHandler', 'WaitHandler')
    process_handler.Process = 'Wait'
    process_handler.Script = script_content
    print 'Created "WaitHandler" behavior.'
  #process_handler.IconUri = iconuri
  
  #Statement
  icon_path = getCommandPath()[8:]
  base, filename = os.path.split(icon_path)
  icon_path = os.path.join( base, 'sWaitExp.svg' )
  
  scope = app.TeachContext.ActiveScope
  prev_stat =  app.TeachContext.ActiveStatement
  index = -1
  if app.TeachContext.ActiveStatementIndex >= 0:
    index = app.TeachContext.ActiveStatementIndex + 1
  stat = scope.addStatement('Process',index, icon_path)
  p1 = stat.createProperty(VC_STRING, 'Expression')
  p1.Value = 'DO[1] == ON'
  p2 = stat.createProperty(VC_REAL, 'PollCycle')
  p2.Quantity = 'Time'
  p2.Value = 0.01
  stat.Process = process_handler
  app.render()
  app.SelectionManager.setSelection(stat)


def handler():
  handler_path = getCommandPath()[8:]
  base, filename = os.path.split(handler_path)
  handler_path = os.path.join( base, 'WaitHandler.py' )
  with open(handler_path, 'r') as handler_file:
    content = handler_file.read()
    return content
    
